<?php


namespace app\widgets;


use app\widgets\assets\GridViewAsset;
use yii\bootstrap5\ButtonDropdown;
use yii\grid\DataColumn;
use yii\helpers\Html;

/**
 * How to use the $gridPageSize dropdownList under thew Grid:
 * - Your GridView must have attribute: 'filterModel' => $searchModel
 * - The grid view must be app\widgets\GridView not yii\grid\GridView
 * - Then the dropdown is automatically added under the GridView
 * - To make it work you also need to modify your Search model like this:
 * public function rules()
 * {
 *     return [
 *         // ...
 *         $this->gridPageSizeRule,
 *     ];
 * }
 *
 * Plus modify the search() method:
 * public function search($params)
 * {
 *     $query = YourModel::find();
 *     $this->load($params);
 *
 *     // Page size:
 *     if (!isset($this->gridPageSize)) {
 *         $this->gridPageSize = $this->gridPageSizeDefault;
 *     }
 *
 *     $dataProvider = new ActiveDataProvider([
 *         'query' => $query,
 *         'pagination' => ['pageSize' => (int)$this->gridPageSize],
 *     ]);
 *  // ...
 * }
 *
 * It is also important that your Search model extends from the standard model and it extends from app\models\BaseModel
 *
 * Example can be found in the User model + view index.php
 *
 * Class GridView
 * @package app\widgets
 */
class GridView extends \yii\grid\GridView
{

    /**
     * 'rowDragSort' => [
     *   'url' => \yii\helpers\Url::to(['sort'])
     *   'pkCol' => 'id',
     * ],
     * @var array
     */
    public $rowDragSort = [];

    /**
     * 'tbodyOptions' => [
     *   'class' => 'row_position ui-sortable',
     *   'data-sort-url' => \yii\helpers\Url::to(['sort', 'groupId' => $groupId, 'pjaxId' => $pjaxId])
     * ],
     * In order to sort table rows, the tbody must be made sortable, not the table.
     * @link https://api.jqueryui.com/sortable/
     *
     * @var array
     */
    public $tbodyOptions = [];

    public $layout = '{summary}<br>{items}';

    /**
     * If we want o to display page-size-selector under the GridView, we need the instance of the search-model which is saved to attribute $filterModel
     * On the other hand if this $filterModel is set, filters are displayed. But In this project we want to hide filters.
     * So $showFilters allows us to use $filterModel while keeping filters hidden.
     * @var bool
     */
    public $showFilters = true;

    /**
     * 'topButtons' => [
     *     [
     *         'label' => 'Export',
     *         'options' => [
     *             'class' => 'btn btn-outline-secondary p-0',
     *         ],
     *         'buttonOptions' => [
     *             //'style' => 'color:red;',
     *         ],
     *         'items' => [
     *             [
     *                 'label' => 'CSV - Ignore grid setup',
     *                 'url' => Url::to(['index', 'exportTo' => 'csv']),
     *                 'linkOptions' => ['data-pjax' => 0],
     *             ],
     *             [
     *                 'label' => 'CSV - Respect grid setup2',
     *                 'url' => Url::current(['exportTo' => 'csv']),
     *                 'linkOptions' => ['data-pjax' => 0],
     *             ],
     *         ],
     *     ],
     *
     *     [
     *         'label' => 'Export 2',
     *         'options' => ['class' => 'btn btn-secondary'],
     *         'url' => Url::to(['index', 'exportTo' => 'csv']),
     *     ]
     * ],
     *
     * @var array
     */
    public $topButtons = [];

    public $pageSizeTitle = 'Rows per page';

    public function renderFilters()
    {
        if ($this->showFilters) {
            return parent::renderFilters();
        }
        return '';
    }

    public function init()
    {
        $this->processRowDragSort();
        $this->processTopButtons();
        parent::init(); // TODO: Change the autogenerated stub
        GridViewAsset::register($this->getView());

        if ($this->filterModel) {
            $searchModel = $this->filterModel;
            $pageSizeDropDown = $this->pageSizeTitle . ': ' . $searchModel->getGridPageSizeDropDown(['class' => 'form-control text-center', 'style' => 'width: 5rem;display:inline;']);
            $gridViewPagerWrapper = '<div class="gridViewPagerWrapper1"><div class="gridViewPagerWrapper2">{pager}</div><div class="gridViewPagerWrapper3">' . $pageSizeDropDown . '</div></div>';
            $this->layout .= '<br>' . $gridViewPagerWrapper;
            $this->filterSelector = $searchModel->getGridPageSizeDropDownID();
        }

    }

    /**
     * Renders the table body.
     * This method is just a copy of identical method in the parent class
     * Because I needed to add one small enhancement
     * @return string the rendering result.
     */
    public function renderTableBody()
    {
        $models = array_values($this->dataProvider->getModels());
        $keys = $this->dataProvider->getKeys();
        $rows = [];
        foreach ($models as $index => $model) {
            $key = $keys[$index];
            if ($this->beforeRow !== null) {
                $row = call_user_func($this->beforeRow, $model, $key, $index, $this);
                if (!empty($row)) {
                    $rows[] = $row;
                }
            }

            $rows[] = $this->renderTableRow($model, $key, $index);

            if ($this->afterRow !== null) {
                $row = call_user_func($this->afterRow, $model, $key, $index, $this);
                if (!empty($row)) {
                    $rows[] = $row;
                }
            }
        }

        // This is the only difference.
        // <tbody> sometimes needs to have a class. (eg: if the table is sortable)
        $tbodyStart = Html::beginTag('tbody', $this->tbodyOptions);

        if (empty($rows) && $this->emptyText !== false) {
            $colspan = count($this->columns);

            return "$tbodyStart\n<tr><td colspan=\"$colspan\">" . $this->renderEmpty() . "</td></tr>\n</tbody>";
        }

        return "$tbodyStart\n" . implode("\n", $rows) . "\n</tbody>";
    }

    private function processRowDragSort()
    {
        if (!is_array($this->rowDragSort) || empty($this->rowDragSort)) {
            return;
        }
        $url = $this->rowDragSort['url'];
        $pkCol = $this->rowDragSort['pkCol'] ?? 'id';
        $this->tbodyOptions = [
            'class' => 'row_position ui-sortable',
            'data-sort-url' => $url,
        ];
        $this->rowOptions = function ($model, $key, $index, $grid) use ($pkCol) {
            return [
                'id' => $model->$pkCol,
            ];
        };
        $this->columns = array_merge([$this->getSortColumn()], $this->columns);
    }

    private function getSortColumn()
    {
        return [
            'class' => DataColumn::class,
            'format' => 'html',
            'label' => '',
            'contentOptions' => [
                'class' => 'handleCol',
            ],
            'value' => function ($model, $key, $index, $column) {
                return '<span class="handle ui-sortable-handle"><i class="bi bi-grip-vertical"></i></span>';
            },
        ];
    }

    private function processTopButtons()
    {
        if (!is_array($this->topButtons) || empty($this->topButtons)) {
            return;
        }

        $buttons = [];
        foreach ($this->topButtons as $button) {
            if (isset($button['items'])) {
                $buttons[] = ButtonDropdown::widget([
                    'label' => $button['label'],
                    'options' => $button['options'] ?? [],
                    'buttonOptions' => $button['buttonOptions'] ?? [],
                    'dropdown' => [
                        'items' => $button['items'],
                    ],
                ]);
            } else {
                $buttons[] = Html::a($button['label'], $button['url'], $button['options'] ?? []);
            }
        }
        $this->layout = implode('&nbsp;', $buttons) . "<br><br>" . $this->layout;
    }
}